/* -*- mode: c++; c-basic-offset: 4; -*- */
#include <time.h>
#include "NameClient.hh"
#include <cstring>
#include <cstdlib>
#include <iostream>

using namespace lmsg;
using namespace std;

int 
main(int argc, const char** argv) {

    //----------------------------------  Parse the command line.
    bool syntax(argc < 2); 
    MsgAddr addr;
    NameProcs pType = p_Monitor;
    for (int i=1 ; i<argc-1 ; i++) {
        if (!strcmp(argv[i], "-a")) {
	    addr = MsgAddr::findIPHost(argv[++i]);
	} else if (!strcmp(argv[i], "-p")) {
	    addr.setIPPort(strtol(argv[++i], 0, 0));
	} else if (!strcmp(argv[i], "-t")) {
	    pType = static_cast<NameProcs>(strtol(argv[++i], 0, 0));
	} else {
	    cerr << "Unrecognized argument: " << argv[i] << endl;
	    syntax = true;
	    break;
	}
    }
    if (syntax) {
        cerr << argv[0] << " command syntax:" << endl;
	cerr << "    addName [-a <ip-address>] [-p <ip-port>] [-t <type>]"
	     << " <name>"<< endl;
	return 1;
    }

    //-----------------------------------  Construct a name client, add name.
    NameClient nc;
    // nc.setDebug(1);
    int rc = nc.addName(argv[argc-1], addr, pType);
    if (rc) cerr << "Error in request: " << rc << endl;
    return rc;
}
